
--fixme: cleanup & reorganize this mess

local function isHovering(item, x, y)
    if not item then return nil end
    local x, y = love.mouse.getPosition()
    if x >= item.x and y >= item.y and x <= item.x + item.w and y <= item.y + item.h then return true end
end

-- init
local width, height = love.graphics.getDimensions()
local help = {} -- this help module
local gui = {} -- user interactive elements
local hand = love.mouse.getSystemCursor("hand")
local white = {1, 1, 1}
local url = {0.5, 0.7, 1}
local links = {
    "https://www.1001fonts.com/unispace-font.html",
    "Expat (MIT) license",
    "https://love2d.org/forums/memberlist.php?mode=viewprofile&u=139789"}

-- licenses statement (coloredtext table)
help.licenses = {
    white, '\n\n"Unispace" font is copyright 2020 by Typodermic Fonts Inc\n',
    url,   links[1],
    white, "\n\nWordie is copyright 2022 by milon\n",
    url,   links[2],
    white, "\n\nWordie is made with Löve! Find out more at\n",
    url,   links[3]}

-- calculate line height
local textObj = love.graphics.newText(window.sysFont, "Wordie")
local lineHeight = textObj:getHeight()
textObj:release()

-- help text
help.instructions = [[WORDIE

An open source implementation of Worlde
Try to guess the 5 letter word in 6 guesses or less

Use mouse or keyboard to input a guess and press Enter to submit it
Backspace deletes 1 letter, Escape clears the current guess

A Green letter is correct
A Yellow letter is in the wrong location
A Dark Gray letter is not in the word at all]]

-- Wordie license text
help.licenseText = [[Copyright 2022 by milon

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.]]
textObj = love.graphics.newText(window.sysFont, help.licenses)
local licenseHeight = textObj:getHeight()
textObj:release()

-- calculate URL regions
for i = 1, #links do
    gui[i] = {x=40, link=links[i]}
    textObj = love.graphics.newText(window.sysFont, links[i])
    gui[i].w, gui[i].h = textObj:getDimensions()
    textObj:release()
end

function help.draw()
    state.game.draw()

    love.graphics.setColor(0, 0, 0, 0.8)
    love.graphics.rectangle("fill", 20, 20, width - 40, height - 40, 10, 10)
    love.graphics.setColor(1, 1, 1)
    love.graphics.printf(help.instructions, window.sysFont, 40, 40, width - 80, "center")
    love.graphics.print(help.licenses, window.sysFont, 40, height - licenseHeight - lineHeight - 20)

    for i = 1, #gui do
        if isHovering(gui[i]) then
            love.graphics.line(gui[i].x, gui[i].y + gui[i].h, gui[i].x + gui[i].w, gui[i].y + gui[i].h)
        end
    end
end

function help.keyreleased()
    love.mouse.setCursor()
    state.current = state.game
end

function help.mousemoved()
    for i = 1, #gui do
        if isHovering(gui[i]) then
            love.mouse.setCursor(hand)
            return
        end
    end
    love.mouse.setCursor()
end

function help.mousereleased()
    for i = 1, #gui do
        if isHovering(gui[i]) then
            if i == 2 then
                love.window.showMessageBox("Wordie", help.licenseText)
            else
                love.system.openURL(gui[i].link)
            end
            return
        end
    end
    love.mouse.setCursor()
    state.current = state.game
end

function help.resize(w, h)
    width, height = w, h
    for i = 1, #gui do
        gui[i].y = height - 20 - licenseHeight + lineHeight * ((i - 1) * 3 + 2)
    end
end

help.resize(width, height)

return help
